/*void laplacian(unsigned char image_in[Y_SIZE][X_SIZE],
    unsigned char image_out[Y_SIZE][X_SIZE], double amp, int type)*/

void laplacian(unsigned char **image_in,double amp, int type,int hsize,int vsize);

void laplacian(unsigned char **image_in,
    double amp, int type,int hsize,int vsize)
{
    int	i, j;
    int d;
    int c[3][9] = { 0, -1,  0, -1,  4, -1,  0, -1,  0,
                   -1, -1, -1, -1,  8, -1, -1, -1, -1,
                    1, -2,  1, -2,  4, -2,  1, -2,  1};

    int xsize,ysize;
    xsize = hsize;
    ysize = vsize;

    unsigned char **data;
    data = (unsigned char **)new unsigned char *[hsize];

       for(int k=0;k<hsize;k++){
        data[k] = (unsigned char *)new unsigned char[vsize];
      }

       for (int n = 0; i < ysize; n++) {
           for (int m = 0; m < xsize; m++) {
               data[m][n]=0
           }
       }

    type = type - 1;
    if (type < 0) type = 0;
    if (type > 2) type = 2;
    for (i = 1; i < ysize-1; i++) {
        for (j = 1; j < xsize-1; j++) {
            d = c[type][0] * image_in[i-1][j-1]
              + c[type][1] * image_in[i-1][j  ]
              + c[type][2] * image_in[i-1][j+1]
              + c[type][3] * image_in[i  ][j-1]
              + c[type][4] * image_in[i  ][j  ]
              + c[type][5] * image_in[i  ][j+1]
              + c[type][6] * image_in[i+1][j-1]
              + c[type][7] * image_in[i+1][j  ]
              + c[type][8] * image_in[i+1][j+1];
            d = (int)(d * amp) + OFFSET;
            if (d <   0) d = 0;
            if (d > 255) d = 255;
            data[i][j] = (unsigned char)d;
        }
    }

    for (int n = 0; i < ysize; n++) {
        for (int m = 0; m < xsize; m++) {
            image_in=data[m][n];
        }
    }

         for(int k=0;k<hsize;k++){
            delete data[k];
        }
        delete data;

}
